//
// bsmtp.cc
//				Author Tatsuo Baba
//				2000.02.19 Porting start Windows -> linux 
//				2000.11.03 Support qmail-queue interface
//				           Fix daylight 1000 -> 0900
//
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/resource.h>
#include "bsmtp.h"
#include "bclass.h"
#include "bwsock.h"
#include "rfc1468.h"
#include "kconv.h"
#include "qminter.h"

#define CRLF "\015\012"

//2000.01.14 Increase MAXCHARLEN  8192->65536
#define MAXCHARLEN 65536 
//2000.01.14 Increase MAXTO  512->4096
#define MAXTO 4096 

// 2000.01.20 Support option
#define OPT_DELETE_HEADER 1
#define OPT_BCC_FROM_FILE 2
#define OPT_TRANSFER 4
#define OPT_TEST_MODE 8

// prototypes
static 
int MailTo(char* szServer,char* szTo[], int uToArrSize, int *nToFlag,
char* szFrom,char* szSubject, char* szData, char* szFile,int option,char* msg);

void GetCurrentRFC822Date(char * pszBuffer);

void get_msgid(char*from,char *msgidbuf);

// linux specific kanji encoding
#define J_UNKNOWN_CODE 0
#define J_SJIS_CODE 1
#define J_EUC_CODE  2
#define J_JIS_CODE  3


////

extern "C"
int BSendMail(char* ipaddr,// smtp ip address
            char* to,		// TO  split by tab char
            char* from,	// FROM
            char* subject,// SUBJECT
            char* body,	// BODY
            char* file,   // Attach Files  split by tab char
            char* msg)	  // 80 bytes length message area
{
		int jtype = J_UNKNOWN_CODE; // default is unknown		
		if (ipaddr[0] == '-')	{	// kanji encoding argument start ?
			if (strncasecmp(ipaddr+1,"sjis ",5) == 0)
				jtype = J_SJIS_CODE;
			else if (strncasecmp(ipaddr+1,"euc ",4) == 0)
				jtype = J_EUC_CODE;
			else if (strncasecmp(ipaddr+1,"jis ",4) == 0)
				jtype = J_JIS_CODE;
		}
		char *realip = strchr(ipaddr,' ');
		if (realip)
			realip++;
		else
			realip = ipaddr;
		// japanese character encoding
		KConv kto,kfrom,ksubject,kbody;
		char* szServer = realip;
		char* szTo = kto.Conv(to,strlen(to),jtype,J_SJIS_CODE);
		char* szFrom = kfrom.Conv(from,strlen(from),jtype,J_SJIS_CODE);
		char* szSubject = ksubject.Conv(subject,strlen(subject),jtype,J_SJIS_CODE);
		char* szBody = kbody.Conv(body,strlen(body),jtype,J_SJIS_CODE);
		char* szFile = file;
	
	if (!msg) {
		return 0;
	}
	if (!szServer || !szTo || *szServer == 0 || *szTo == 0) {
		strcpy(msg,"BAD Server or TO field");
		return 0;
	}
	if (strlen(szTo) > MAXCHARLEN) {
		strcpy(msg,"TO field too long");
		return 0;
	}

	if (!szFrom || *szFrom == 0) {
		strcpy(msg,"FROM field invalid");
		return 0;
	}

	if (szFrom && strlen(szFrom) > MAXCHARLEN) {
		strcpy(msg,"FROM field too long");
		return 0;
	}
	if (szSubject && strlen(szSubject) > MAXCHARLEN) {
		strcpy(msg,"SUBJ field too long");
		return 0;
	}

//	struct _stat buf;
	int lastpos = 0;
	BCStr s;
	if (szFile && szFile[0] != '\0') {
		char *tp = new char[strlen(szFile) +2];
		memcpy(tp,szFile,strlen(szFile) +1);
		for (register int i = 0;tp[i] != 0;i++){
			if (tp[i] == '\t') {	// find tab 
				tp[i] = 0;
				// 2000.01.08 nick name support
				s.Clear();
				s.Add(tp+lastpos,strlen(tp+lastpos));
				s.Find('|');
				if (1 != BFileAttr(s.GetBuffer()))
					goto file_notfound;
				lastpos = i + 1;
			}
		}
	
		// 2000.01.08 nick name support
		s.Clear();
		s.Add(tp+lastpos,strlen(tp+lastpos));
		s.Find('|');
		if (1 != BFileAttr(s.GetBuffer())) {
			file_notfound:
			strcpy(msg,"File notfound  ");
			// 1999.10.23 FIX msg overflow 
			if (strlen(tp + lastpos) > 50)
				tp[lastpos+50] = 0;
			strcat(msg,tp + lastpos);
			delete [] tp;
			return 0;
		}
		delete [] tp;
	}

	char *pToArray[MAXTO];
	int nToFlag[MAXTO];
	memset(pToArray,0,sizeof(char*)*MAXTO);
	memset(nToFlag,0,sizeof(int)*MAXTO);

	BCStr wk;
	wk.Add((char*)szTo,strlen(szTo));

    pToArray[0]   = wk.GetBuffer();

	// each TO field split by TAB character
	int mode = 1;	// To mode
	nToFlag[0] = mode;	// default is To
	char *tp = pToArray[0];
	char *tptop;
        int nToArrSize = 0;
	char *charset = NULL;
	//2000.01.14 Support To: @header only mode = 6
	while (tptop = Strchr(tp,'\t')) {
		if (nToArrSize >= MAXTO) {	// over max
			strcpy(msg,"TO field tab over");
			return 0;
		}
		tptop[0] = 0;
		if (strcasecmp(tp,"cc") == 0) {
			mode = 2;
			tp = tptop+1;
			continue;
		}
		if (strcasecmp(tp,"bcc") == 0) {
			mode = 3;
			tp = tptop+1;
			continue;
		}
		if (strcasecmp(tp,"reply-to") == 0) {
			mode = 4;
			tp = tptop+1;
			continue;
		}
		if (tp[0] == '>') {  // special Header
			mode = 5;
		} else {
			if (Strchr(tp,'@') == NULL) {	// invalid address
				char temp[512];
				strcpy(temp,"TO filed invalid ");
				strcat(temp,tp);
				// 1999.10.23 FIX msg overflow 
				if (strlen(temp) > 79)
					temp[79] = 0;
				strcpy(msg,temp);
				return 0;
			}
			//2000.01.14 Support TO: @header
			if (tp[0] == '@')
				mode = 6;
		}
		if (mode == 5) {
			if (strncasecmp(tp,">to:",4) == 0) {
				mode = 1;
				tp = tp+4;
			}
			if (strncasecmp(tp,">cc:",4) == 0) {
				mode = 2;
				tp = tp+4;
			}
			if (strncasecmp(tp,">bcc:",5) == 0) {
				mode = 3;
				tp = tp+5;
			}

			// 1999.08.26 Support other charset
			if (strncasecmp(tp,">content-type",13) == 0 && 
				strstr(tp,"multipart") == NULL) // 2000.10.29 multipart support
				charset = tp+13;	// 2000.09.14 
			
			while (tp[0] == ' ') // skip blank
				tp++;
		}
		
		// 1999.10.16 Check null
		if (tp[0] == 0) {
			strcpy(msg,"TO filed invalid");
			return 0;
		}
		nToFlag[nToArrSize] = mode;
		pToArray[nToArrSize++] = tp;
		tp = tptop+1;
		if (mode == 5)	// 1999.08.27 FIX if special header first
			mode = 0;
	}
		// 1999.10.16 Check null
	if (tp[0] == 0) {
		strcpy(msg,"TO filed invalid");
		return 0;
	}

	if (mode == 4 && nToArrSize == 0) {
		strcpy(msg,"TO filed invalid only reply-to field");
		return 0;
	}

	//2000.01.14 Support TO: @header
	if (tp[0] == '@' && nToArrSize == 0) {
		strcpy(msg,"TO filed invalid");
		return 0;
	}
	if (tp[0] == '>') {   // special Header
		mode = 5;
		if (strncasecmp(tp,">to:",4) == 0) {
			mode = 1;
			tp = tp+4;
		}
		if (strncasecmp(tp,">cc:",4) == 0) {
			mode = 2;
			tp = tp+4;
		}
		if (strncasecmp(tp,">bcc:",5) == 0) {
			mode = 3;
			tp = tp+5;
		}
		// 1999.08.26 Support other charset
		if (strncasecmp(tp,">content-type",13) == 0 &&
				strstr(tp,"multipart") == NULL) // 2000.10.29 multipart support
			charset = tp+13;	// 2000.09.14 fix charset

		while (tp[0] == ' ') // skip blank
			tp++;
	}
	
	nToFlag[nToArrSize] = mode;
	pToArray[nToArrSize++] = tp;


///////////////////////////////////////////////////////////////////////////
//  convert Non-ASCII character for ISO-2022-JP
///////////////////////////////////////////////////////////////////////////
	// to
	CRFC1468 rfc1468;
	// 1999.08.26 Support other charset
	if (charset)
			rfc1468.SetCharset(charset); // 2000.09.14 fix charset

    char *pFrom, *pSubject,*pBody,*pFile;
	char *pContent_type = NULL;		// 1999.3.5 support Content-Type
    pFrom = pFile = pBody = pSubject = NULL;
	int option = 0;		// 2000.01.20 Support option
	char *xfrfile = 0;
    for (int i = 0; i < nToArrSize; i++) {
		tp = pToArray[i];
		pToArray[i] = 0;	// 2000.01.20 option value
		if (tp[0] == '>') {   // special Header
			if (tp[1] == '#') { // 2000.01.17 option value 
								// >#dheader   - delete specified header
								//               when transfer mail
								// >#bcc file  - Bcc input from files 
								// >#xfr file  - transfer mail 
								// >#test file - test mode 
				if (strncasecmp(tp+2,"test ",5) == 0) {
					char *newtemp = new char [strlen(tp) + 2];
					strcpy(newtemp,tp);
					pToArray[i] = newtemp;
					option = option | OPT_TEST_MODE;
					continue;
				}
				if (strncasecmp(tp+2,"d",1) == 0) {
					char *newtemp = new char [strlen(tp) + 2];
					strcpy(newtemp,tp);
					pToArray[i] = newtemp;
					option = option | OPT_DELETE_HEADER;
					continue;
				}
				if (strncasecmp(tp+2,"bcc ",4) == 0) {
					if (1 != BFileAttr(tp+6)) { // file check
						strcpy(msg,"bcc file not found");
					    for (int j = 0; j < i; j++)	// 2000.01.20
							delete [] pToArray[j];
						return 0;
					}
					// check correct file speified
					BFile ls(tp+6);
					char *line;
					int lno = 0; // 2000.10.28
					while (line = ls.GetLine()){
						lno++; // 2000.10.28
						if (line[0] == '#' || line[0] == 0)
							continue;
						if (strchr(line,'@'))
							continue;
						sprintf(msg,"bcc file invalid mail address %ld ",lno);
						if (strlen(line) > 40)
							line[40] = 0;
						strcat(msg,line); // 2000.10.28 FIX msg correct
					    for (int j = 0; j < i; j++)	// 2000.01.20
							delete [] pToArray[j];
						return 0;
					}
					// ok mail-address
					char *newtemp = new char [strlen(tp) + 2];
					strcpy(newtemp,tp);
					pToArray[i] = newtemp;
					option = option | OPT_BCC_FROM_FILE;
					continue;
				}
				if (strncasecmp(tp+2,"xfr ",4) == 0) {
					if (1 != BFileAttr(tp+6)) { // file check
						strcpy(msg,"transfer file not found");
					    for (int j = 0; j < i; j++)	// 2000.01.20
							delete [] pToArray[j];
						return 0;
					}
					char *newtemp = new char [strlen(tp) + 2];
					strcpy(newtemp,tp);
					pToArray[i] = newtemp;
					option = option | OPT_TRANSFER;
					xfrfile = tp + 6;
					continue;
				}
				// other is error
				strcpy(msg,"invalid option");
			    for (int j = 0; j < i; j++)	// 2000.01.20
					delete [] pToArray[j];
				return 0;
			}
			if ((tptop = Strchr(tp,':')) == NULL) {// invalid address
				strcpy(msg,"TO filed invalid");
			    for (int j = 0; j < i; j++)	// 2000.01.20
					delete [] pToArray[j];
				return 0;
			}
			if (tptop[1] == 0 || tptop[2] == 0) { // invalid address
				strcpy(msg,"TO filed invalid");
			    for (int j = 0; j < i; j++)	// 2000.01.20
					delete [] pToArray[j];
				return 0;
			}
			if (strlen(tp+1) > 14 && strncasecmp(tp+1,"Content-Type",12) == 0) {
				pContent_type = tp + 1;
				char *newtemp = new char [strlen(tp) + 2];
				strcpy(newtemp,tp);
				pToArray[i] = newtemp;

				continue;
			}
			char *temp;
			if (tptop[1] == ' ') { // "xxxx: yyyy" or "xxxx:yyy" ?
				temp = rfc1468.ConvToFrom(tptop+2);
				tptop[2] = 0;
			}
			else {
				temp = rfc1468.ConvToFrom(tptop+1);
				tptop[1] = 0;
			}
			char *newtemp = new char [strlen(tp) + strlen(temp) + 2];
			strcpy(newtemp,tp);
			strcat(newtemp,temp);
			delete [] temp;
			pToArray[i] = newtemp;
		}
		else {
			pToArray[i] = rfc1468.ConvToFrom(tp);
		}
	}
	// from
	if (szFrom)
		pFrom = rfc1468.ConvToFrom(szFrom);
	// subject
	if (szSubject)
		pSubject = rfc1468.ConvSubject(szSubject);

	// 2000.01.20 Support transfer mode
	char newfile[L_tmpnam];
	if (option & OPT_TRANSFER) {
		// read transfer mail contents 
		BFile xfr(xfrfile);	//=======================
		if (NULL == tmpnam(newfile))
			newfile[0] = 0;
		FILE *hfile = fopen(newfile,"wb");
		if (hfile == NULL){
			strcpy(msg,"cannot create transfer tempfile");
		    for (int j = 0; j < nToArrSize; j++)
				delete [] pToArray[j];
			return 0;
		}
		char *line;
		int delf = 0;
		int subjfound = 0;	// 2000.02.28 subject found flag

		static char delh[7][16] =		// "Received:",
		{ "X-Mailer:","X-Mail-Agent:","Status:","To:",
			"Return-Path:","Delivered-To:","Message-ID:"}; // 2000.03.06 messageid also delete 

		while (line = xfr.GetLine()) {
			if (line[0] == 0)	// end of header
				break;
			if (delf && line[0] <= ' ')	// delete continue header
				continue;
			else {
				if (line[0] > ' ' && NULL == strchr(line,':')) {	// not header
					strcpy(msg,"invalid transfer file");
				    for (int j = 0; j < nToArrSize; j++)
						delete [] pToArray[j];
					fclose(hfile);
					remove(newfile);
					return 0;
				}
			}
			delf = 0;
			if (line[0] > ' ') { // header start ?
			
				for (int j = 0;j < 7;j++) {
					if (strncasecmp(line,delh[j],strlen(delh[j])) == 0) {
						delf = 1;
						break;
					}
				}
				if (delf)
					continue;
				// delete header 
				for (int i = 0; i < nToArrSize; i++) {
					char *tp = pToArray[i];
					if (strncasecmp(tp,">#d",3) == 0) {
						if (strncasecmp(tp+3,line,strlen(tp+3)) == 0) {
							delf = 1;
							break;
						}
					}
				}
				if (delf)
					continue;
				if (strncasecmp(line,"Subject:",8) == 0) {
					subjfound = 1;
					if (pSubject && pSubject[0] != 0) {
						line[8] = ' ';	// 2000.02.28 FIX empty subject
						strcpy(line+9,pSubject);	// change subject
						delf = 1;		// 2000.01.31 FIX remain old subject 
					}
				}
			}
			fwrite(line,1,strlen(line),hfile);
			fwrite(CRLF,1,2,hfile);
		}
		// 2000.02.28 check subject 
		if (subjfound == 0 && pSubject && pSubject[0] != 0) {	// no subject
			fwrite("Subject: ",1,9,hfile);
			fwrite(pSubject,1,strlen(pSubject),hfile);
			fwrite(CRLF,1,2,hfile);
		}

		static char x_mail[] =	"X-Mail-Agent: bsmtp-1.0  "
								__DATE__
								"  by Tatsuo Baba" CRLF CRLF;

		//WriteFile(hfile,x_mail,strlen(x_mail),&numwrite,0);
		fwrite(x_mail,1,strlen(x_mail),hfile);
		while (line = xfr.GetLine()) {
			if (memcmp(line,".\0",2) == 0)	// only .
				strcat(line,".");
			fwrite(line,1,strlen(line),hfile);
			//WriteFile(hfile,line,strlen(line),&numwrite,0);
			//WriteFile(hfile,CRLF,2,&numwrite,0);
			fwrite(CRLF,1,2,hfile);
		}
		//CloseHandle(hfile);
		fclose(hfile);
		pFile = newfile;
	} else {
		// body
		if (szFile == NULL || szFile[0] == '\0') {		// no file
			if (szBody)
				// 1999.3.5 support Content-Type 
				pBody = rfc1468.ConvBody(szBody,pContent_type); 
		}
		else {
			if (szFile)
				pFile = rfc1468.ConvMulti(szBody,szFile,pContent_type);
		}
	}

///////////////////////////////////////////////////////////////////////////
//  end of convert Non-ASCII character for ISO-2022-JP
///////////////////////////////////////////////////////////////////////////


    int result;
    if (strstr(szServer,"qmail-queue") == 0)
      result = MailTo(szServer,(char**)pToArray, nToArrSize,
		nToFlag,pFrom, pSubject, pBody, pFile,option,msg);
    else  // Support qmail-queue interface  maybe faster
      result = MailToqmail(szServer,(char**)pToArray, nToArrSize,
		nToFlag,pFrom, pSubject, pBody, pFile,option,msg);

    if (pFile)
	remove(pFile);

    int i;	
    for (i = 0; i < nToArrSize; i++)
	    delete [] pToArray[i];
    delete [] pFrom;
    delete [] pSubject;
    delete [] pBody;
	// 2000.01.21 Support Transfer mode
	if (!(option & OPT_TRANSFER))
	    delete [] pFile;

    return result;
}





static int CheckResp(BSocket &s,char* buf,int resp)
{
    s.ReadString(buf, 4095);
    buf[79] = '\0';		// cut 80 bytes length
    if( atoi(buf ) == resp || memcmp(buf,"220",3) == 0) // 1998/1/21  220 always OK
	      return 0;
	

	if (buf[0] == 0)
		strcpy(buf,"time out");


	return 1;
}


static int MailTo(char* szServer,char* szTo[], int uToArrSize,
						int *nToFlag,char* szFrom,
						  char* szSubject, char* szData, char* szFile,
						  int option,char *msg)
{
	
    char buf[4096];

// get port
	char svname[512];
	long port = 25;  // default is 25
	long timeout = 120;  // default is 120 sec
	memset(svname,0,sizeof(svname));

	int svlen = strlen(szServer);	// 1999.11.22 FIX szServer string
	if (svlen < 512) {
		strcpy(svname,szServer);
	} else {
		memcpy(svname,szServer,510);
		svname[511] = 0;
	}

	// 2000.01.04 domain name support
	char hostname[128];		// 1999.3.13  HELO command
	hostname[0] = 0;
	char *dname = Strchr(svname,'/');
	if (dname) {
		memcpy(hostname,svname,dname-svname);
		strcpy(svname,dname+1);
		hostname[dname-svname] = 0;
	} else {
		strcpy(hostname,"localhost");
	}

	char *tpx = Strchr(svname,'\t');
	if (tpx == NULL)			// 1999.06.13 also ":"  is ok
		tpx = Strchr(svname,':');
	if (tpx) {
		tpx[0] = 0;
		char *tptime = Strchr(tpx+1,'\t');
		if (tptime == NULL)			// 1999.06.13 also ":" is ok
			tptime = Strchr(tpx+1,':');
		if (tptime) {
			tptime[0] = 0;
			timeout = atol(tptime+1);
		}
		port = atol(tpx+1);
	    if( port <= 0 || port > 65535) {
		      strcpy(msg,"Invalid port number");
			  return 0;
		}
	}
// create socket
    BSocket s;

// connect socket
	int src = s.Connect(svname, port,timeout);
    if(src != 0) {
		sprintf(buf,"Cant connect Server %ld",src);
		strcpy(msg,buf);
	    return 0;
	}
		
	if (CheckResp(s,buf,220)) {
		strcpy(msg,buf);
		return 0;
	}


// send HELO

	tpx = Strchr(hostname,'~');
	if (tpx) {
		sprintf(buf,"HELO %s\015\012",tpx+1);
	} else {
		sprintf(buf,"HELO %s\015\012",hostname);
	}
    s.WriteString(buf,strlen(buf)); 
    s.Flush();

	// not 250 or 220 is error
	if (CheckResp(s,buf,250) && memcmp(buf,"220",3) ) {
		strcat(buf,"helo ");  // 1999.10.23 FIX msg overflow
		strcat(buf,hostname);
		if (strlen(buf) > 79)
			buf[79] = 0;
		strcpy(msg,buf);
		return 0;
	}

	while (memcmp(buf,"250",3) != 0) {	// wait 250
		if (CheckResp(s,buf,250) && memcmp(buf,"220",3)) {
//			strcpy(msg,buf);
//			strcat(msg," helo ");
//			strcat(msg,hostname);
			strcat(buf,"helo ");  // 1999.10.23 FIX msg overflow
			strcat(buf,hostname);
			if (strlen(buf) > 79)
				buf[79] = 0;
			strcpy(msg,buf);
			return 0;
		}
	}



// MAIL FROM
	char from[1024];
	char *tp = Strrchr(szFrom,'<');
	if (!tp) {	// support   xxx@xxx.com (xxxxx) format
		strcpy(from,szFrom);
		tp = Strrchr(from,'(');
		if (tp) {
			*tp = 0;
			while (tp[-1] == ' ') {  // supress blank
				tp[-1] = 0; tp--;
			}
		}
		tp = from;
	}

    BCStr temp;
	temp.Add("MAIL FROM: ",11);
	temp.Add(tp,strlen(tp));
	temp.Add(CRLF,2);

    s.WriteString(temp.GetBuffer(),temp.GetLength());
    s.Flush();

	if (CheckResp(s,buf,250)) {
		strcat(buf," from ");  // 1999.10.23 FIX msg overflow
		strcat(buf,tp);
		if (strlen(buf) > 79)
			buf[79] = 0;
		strcpy(msg,buf);
//		strcpy(msg,buf);
//		strcat(msg," from ");
//		strcat(msg,tp);
		return 0;
	}

	// 2000.02.24 create Message=ID
	char msgid[128];
	get_msgid(tp,msgid);
	// TO field
//	BCStr tostr,ccstr,bccstr,replystr;
	BCStr tostr,ccstr,replystr;
	int special_header = 0;
    for (int i = 0; i < uToArrSize; i++)
    {
		switch( nToFlag[i] ) 
		{
			case 1:
//				tostr = tostr + ",\015\012   " + szTo[i];
				tostr.Add(",\015\012  ",strlen(",\015\012  "));
				tostr.Add((char*)szTo[i],strlen(szTo[i]));
				break;
			case 2:
//				ccstr = ccstr + ",\015\012   " + szTo[i];
				ccstr.Add(",\015\012  ",strlen(",\015\012  "));
				ccstr.Add((char*)szTo[i],strlen(szTo[i]));
				break;
			case 3:
//				bccstr = bccstr + ",\015\012   " + szTo[i];
//				bccstr.Add(",\015\012   ",strlen(",\015\012   "));
//				bccstr.Add((char*)szTo[i],strlen(szTo[i]));
				break;
			case 4:
//				replystr = szTo[i];
				replystr.Add((char*)szTo[i],strlen(szTo[i]));
				continue;
			case 5:
				special_header++ ;
				continue;
			//2000.01.14 Support TO: @header
			case 6:
				tostr.Add(",\015\012  ",strlen(",\015\012  "));
				tostr.Add((char*)szTo[i],strlen(szTo[i]));
				continue;		// not send as RCPT TO
		}		
		tp = Strrchr(szTo[i],'<');
		if (!tp) {	// support   xxx@xxx.com (xxxxx) format
			strcpy(from,(char*)szTo[i]);
			tp = Strrchr(from,'(');
			if (tp) {
				*tp = 0;
				while (tp[-1] == ' ') {  // supress blank
					tp[-1] = 0; tp--;
				}
			}
			tp = from;
		}
		temp.Clear();
		temp.Add("RCPT TO: ",9);
		temp.Add(tp,strlen(tp));
		temp.Add(CRLF,2);
        s.WriteString(temp.GetBuffer(),temp.GetLength());
        s.Flush();
		if (CheckResp(s,buf,250)) {
			strcat(buf," to ");  // 1999.10.23 FIX msg overflow
			strcat(buf,tp);
			if (strlen(buf) > 79)
				buf[79] = 0;
			strcpy(msg,buf);
//			strcpy(msg,buf);
//			strcat(msg," to ");
//			strcat(msg,tp);
			return 0;
		}
	}

	// 2000.01.21 Support bcc from file
	if (option & OPT_BCC_FROM_FILE) {
		char* bccfile = 0;
		for (int i = 0; i < uToArrSize; i++) {
			if (strncasecmp(szTo[i],">#bcc ",6) == 0) {
				bccfile = szTo[i] + 6;
				break;
			}
		}
		BFile ls(bccfile);
		char *line;
		int lno = 0; // 2000.10.28
		while (line = ls.GetLine()){
			lno++; // 2000.10.28
			if (line[0] == '#' || line[0] == 0)
				continue;
			temp.Clear();
			temp.Add("RCPT TO: ",9);
			if (line[0] != '<') {
				temp.Add("<",1);
				temp.Add(line,strlen(line));
				temp.Add(">",1);
			} else {
				temp.Add(line,strlen(line));
			}
			temp.Add(CRLF,2);
			s.WriteString(temp.GetBuffer(),temp.GetLength());
			s.Flush();
			if (CheckResp(s,buf,250)) {
				char bufx[1024]; // 2000.10.28 FIX msg
				sprintf(bufx,"%s bcc file %ld %s",buf,lno,line);
				if (strlen(bufx) > 79)
					bufx[79] = 0;
				strcpy(msg,bufx);
				return 0;
			}
		}
	}


// DATA
    s.WriteString("DATA\015\012",6);
    s.Flush();

	// 354 or 250 is ok
	if (CheckResp(s,buf,354) && memcmp(buf,"250",3)) {
		strcat(buf," data");  // 1999.10.23 FIX msg overflow
		if (strlen(buf) > 79)
			buf[79] = 0;
		strcpy(msg,buf);
//		strcpy(msg,buf);
//		strcat(msg," data");
		return 0;
	}

	char lastresp[4];
	memcpy(lastresp,buf,3);


//    s.Flush();
	if (tostr.GetLength() > 0) {
		temp.Clear();
		temp.Add("To: ",4);
		temp.Add(tostr.GetBuffer()+5,tostr.GetLength()-5);
		temp.Add(CRLF,2);
		s.WriteString(temp.GetBuffer(),temp.GetLength());
	}
	if (ccstr.GetLength() > 0) {
		temp.Clear();
		temp.Add("Cc: ",4);
		temp.Add(ccstr.GetBuffer()+5,ccstr.GetLength()-5);
		temp.Add(CRLF,2);
	    s.WriteString(temp.GetBuffer(),temp.GetLength());
	}
//	if (bccstr.GetLength() > 0) {
//		temp.Clear();
//		temp.Add("Bcc: ",5);
//		temp.Add(bccstr.GetBuffer()+5,bccstr.GetLength()-5);
//		temp.Add(CRLF,2);
//	    s.WriteString(temp.GetBuffer(),temp.GetLength());
//	}
	if (replystr.GetLength() > 0) {
		temp.Clear();
		temp.Add("Reply-To: ",10);
		temp.Add(replystr.GetBuffer(),replystr.GetLength());
		temp.Add(CRLF,2);
	    s.WriteString(temp.GetBuffer(),temp.GetLength());
	}

	// 2000.01.17 support option
	// >#nnn is option number
	//int option = 0;		// set no option
	// Send special Header
	if (special_header > 0) {
		for (int i = 0; i < uToArrSize; i++)
		{
			if (nToFlag[i] != 5 || szTo[i] == NULL)
				continue;
			tp = (char*)szTo[i];
			if (tp[0] != '>')
				continue;
			// 2000.01.17 support option
			if (tp[1] == '#') {
				//option = atoi(tp+2);
				continue;
			}
			// 2000.09.14 FIX multiple content-type
			if (strncasecmp(tp+1,"content-type",12) == 0)
				continue;

			if (strncasecmp(tp+1,"message-id:",10) == 0)	// 2000.02.24 Message-ID 
				msgid[0] = 0;
			temp.Clear();
			temp.Add(tp+1,strlen(tp+1));
			temp.Add(CRLF,2);
		    s.WriteString(temp.GetBuffer(),temp.GetLength());
		}
	}

	// 2000.02.24 Message-ID
	if (msgid[0] != 0) {
	    s.WriteString(msgid,strlen(msgid));
	}


	//2000.01.17 check option
	int notransfer = !(option & OPT_TRANSFER);
	if (notransfer) { // need date header ?
		// send date header 
		char datebuf[128];
		GetCurrentRFC822Date(datebuf);
		s.WriteString(datebuf,strlen(datebuf));

		temp.Clear();
		temp.Add("From: ",6);
		temp.Add((char*)szFrom,strlen(szFrom));
		temp.Add(CRLF,2);
		s.WriteString(temp.GetBuffer(),temp.GetLength());
	}


	if (notransfer && szSubject) {	// 1999.10.29 FIX check no subject
		temp.Clear();
		temp.Add("Subject: ",9);
		temp.Add((char*)szSubject,strlen(szSubject));
		temp.Add(CRLF,2);
		s.WriteString(temp.GetBuffer(),temp.GetLength());
	}

	if (szData) {
	    s.WriteString((char*)szData,strlen(szData));
	    s.Flush();
	}


	if (szFile) {
		memset(buf,0,sizeof(buf));
		FILE *fp = fopen(szFile,"rb");
//		HANDLE fp = CreateFile(szFile,GENERIC_READ,FILE_SHARE_READ,0,
//			OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);	// 1999.12.10 FILE_ATTRIBUTE_NORMAL
		int numread;
		while (numread = fread(buf,1,sizeof(buf)-1,fp)) {
//		BOOL rc; DWORD numread;
//		do {
//			rc = ReadFile(fp,buf,sizeof(buf)-1,&numread,0);
		    buf[numread] = 0;
		    s.WriteString(buf,numread);
		    s.Flush();
		    memset(buf,0,sizeof(buf));
		}
//		while (numread > 0 && rc);

		fclose(fp);
//		CloseHandle(fp);
	}

	// 250 or 354

	if (memcmp(lastresp,"354",3) != 0) {	// not 354
		if (CheckResp(s,buf,250) && memcmp(buf,"354",3)) {
			 s.WriteString("QUIT\015\012",6);

			strcpy(msg,buf);
			return 0;
		}
	}
	///////// end of message ////////
	s.WriteString("\015\012.\015\012",5); 
	s.Flush();
	CheckResp(s,buf,250);
	
	// close SMTP session
    s.WriteString("QUIT\015\012",6);
	strcpy(msg,buf);	// set latest message

    return 1;
}

void GetCurrentRFC822Date(char * pszBuffer)
{
	struct tm * ptm;
	time_t curtime;
	const char * szDays[] = { "Sun", "Mon", "Tue", "Wed",
		"Thu", "Fri", "Sat" };
	const char * szMonths[] = { "Jan", "Feb", "Mar", "Apr", "May",
		"Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };

	// Set the _tzname, _daylight, and _timezone variables.
	tzset();
	// Get the current time.
	time(&curtime);
	ptm = localtime(&curtime);

	// 1999.09.29 support time-zone
	long daylightx = daylight; //2000.11.03 fix daylight
	long tz = timezone;
	if (tz)  
		tz = 0 - tz / 60 / 60;
	if (daylightx)
		tz = tz + 1;

	sprintf(pszBuffer, "Date: %s, %02d %s %d %02d:%02d:%02d +%02d00\015\012",
		(char*)szDays[ptm->tm_wday],
		ptm->tm_mday,
		(char*)szMonths[ptm->tm_mon],
		ptm->tm_year + 1900,
		ptm->tm_hour,
		ptm->tm_min,
		ptm->tm_sec,
		abs(tz));
	if (tz < 0) {
		char *tp = strchr(pszBuffer,'+');
		tp[0] = '-';
	}

}


void get_msgid(char*from,char *msgid)
{
	char msgidbuf[1024];
	struct tm * ptm;
	time_t curtime;

  struct timeval tv;
  struct timezone tz;
  gettimeofday(&tv, &tz);
        

	// Get the current time.
	time(&curtime);
	ptm = localtime(&curtime);
	strcpy(msgidbuf,from);
	char *tp = msgidbuf;
	char *tp2 = strchr(msgidbuf,'<');
	if (tp2) { 
		tp = tp2 + 1;
		tp2 = strchr(tp,'>');
		if (tp2)
			tp2[0] = 0;
	}
	tp2 = strchr(tp,'@');
	if (tp2)
		tp2[0] = '-';
	sprintf(msgid,"Message-ID: <%d%02d%02d.%02d%02d%02d.%06d-bsmtp@%s>\r\n",
		ptm->tm_year + 1900,
		ptm->tm_mon + 1,
		ptm->tm_mday,
		ptm->tm_hour,
		ptm->tm_min,
		ptm->tm_sec,
		tv.tv_usec,
		tp);

}
