//
//  cbase64.h
//					Author Tatsuo Baba
//

#ifndef _CBASE64_H
#define _CBASE64_H

typedef unsigned char uchar;

class CBase64Enc {
private:
	FILE *m_hfile;
public:
	enum { RESULT_OK = 0, RESULT_ERROR, RESULT_DONE, RESULT_SMALLBUFFER };

	CBase64Enc() : m_hfile(NULL) {};
	virtual ~CBase64Enc()
		{ if (m_hfile != NULL) fclose(m_hfile); };

	int OpenFile(char * pszFileName);
	void CloseFile()
		{ if (m_hfile != NULL)
			fclose(m_hfile);
		   m_hfile = NULL;};

	int EncodeLine(char * pszLine,int size);
	int EncodeLine(int nDataLen,char* pszData,char * pszLine, int nLen);
};

class CBase64Dec {
private:
	FILE *m_hfile;
	uchar	m_uchStoredChars[4];
	int		m_iChars;
public:
	enum { RESULT_OK = 0, RESULT_ERROR = -1 };

	CBase64Dec() : m_hfile(NULL), m_iChars(0) {};
	virtual ~CBase64Dec()
		{ if (m_hfile != NULL) fclose(m_hfile); };

    int OpenFile(char* pszFileName);
    int DecodeLine(char * pszLine, int nLineLen);
    int DecodeLine(char * pszLine, int nLineLen,
    uchar * uchBuffer, int nBufferLen);
};


#endif

