//
//  rfc1468.h
//					Author Tatsuo Baba
//
//	Japanese Character Encoding for Internet Message.
//
//  SMTP Non-ASCII character support
//	ISO-2022-JP  : JIS KANJI support
//
//
//

#ifndef _RFC1468_H
#define _RFC1468_H

#include "bclass.h"
#include "cbase64.h"
#include <sys/time.h>

class CRFC1468 {
public:
	CRFC1468(){
		m_nCharset = 0;
		m_strContentType[0] = 0; // 2000.09.14
		strcpy(m_strCharset,"ISO-2022-JP");  // set default
		strcpy(m_strMIME,"=?ISO-2022-JP?B?");	// set default
                struct timeval tv;
                struct timezone tz;
                gettimeofday(&tv, &tz);
		sprintf(m_strBoundary,"PtErOdAcTyL%06d",tv.tv_usec); // 2000.08.01
	};
	virtual ~CRFC1468(){};

	char *ConvSubject(const char* in);
	char *ConvToFrom(const char* in);
	char *ConvBody(const char* in,char *content_type);
	char *ConvMulti(const char* body,const char* file,char *content_type);

	void SetCharset(const char* name);
	int Sjis2Jis(const char* str,BCStr* out);

private:
	int m_nCharset;			// 
	char m_strContentType[64]; // 2000.09.14
	char m_strCharset[32];	// ie. "ISO-2022-JP"
	char m_strMIME[32];	// ie. "=?ISO-2022-JP?B?"
	char m_strBoundary[64];	// 2000.08.01 boudary

	void PutBase64(char *fname,FILE *fp);
	
	CBase64Enc m_encode;
	int jisleft(char* str,int needlen,char* out);
	int jisinchar(const char* str,char findchar);

};


#endif


